#include "head.h"
#include "unit.h"
#include "grid.h"
#include<stdlib.h> // abs()

#define MAX_UNIT 64

void draw_all(SDL_Renderer * renderer, struct unit * midripod, struct unit * cominex) {
    SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
    SDL_RenderClear(renderer);
    grid_draw(renderer);
    unit_draw(midripod, renderer);
    unit_draw(cominex, renderer);
    SDL_RenderPresent(renderer);
}

void cominex_move(struct unit * cominex) {
    const Uint8 * keyboard = SDL_GetKeyboardState(NULL);
    int dx = 0;
    int dy = 0;

    if(keyboard[SDL_SCANCODE_UP])
        dy--;
    if(keyboard[SDL_SCANCODE_DOWN])
        dy++;
    if(keyboard[SDL_SCANCODE_LEFT])
        dx--;
    if(keyboard[SDL_SCANCODE_RIGHT])
        dx++;
    unit_move(cominex, dx, dy);
}

void midripod_collect(struct unit * midripod, struct unit * unit) {
    if(abs(unit->x - midripod->x)<10 && abs(unit->y - midripod->y)<10) {
        midripod->gem += unit->gem;
        unit->gem = 0;
    }
}

void loop(SDL_Renderer * renderer) {
    SDL_Event event;
    int stop = 0;
    struct unit cominex;
    struct unit midripod;
    unit_init(&midripod, WINDOW_WIDTH/2, WINDOW_HEIGHT/2);
    unit_load_texture(&midripod, "midripod.bmp", renderer);
    midripod.drillpower = 500;
    unit_init(&cominex, WINDOW_WIDTH/2, WINDOW_HEIGHT/2);
    unit_load_texture(&cominex, "cominex.bmp", renderer);
    cominex.drillpower = 1;
    init_grid(renderer, midripod.x, midripod.y);
    unit_dig(&midripod);

    while(!stop) {

        // Update Model
        cominex_move(&cominex);
        midripod_collect(&midripod, &cominex);

        // Draw
        draw_all(renderer, &midripod, &cominex);
        SDL_Delay(10);

        // Process Input
        while(SDL_PollEvent(&event)) {
            if(event.type == SDL_QUIT) {
                stop = 1;
            } else if(event.type == SDL_KEYDOWN) {
                if(event.key.keysym.sym == SDLK_ESCAPE) {
                    stop = 1;
                } else if(event.key.keysym.sym == SDLK_SPACE) {
                    unit_dig(&cominex);
                }
            }
        }
    }

    // Clean
}
