#include "head.h"
#include "unit.h"
#include "grid.h"

/*
int x_valid(int x) {
    return(x >= 0 && x <= WINDOW_WIDTH);
}

int y_valid(int y) {
    return(y >= 0 && y <= WINDOW_HEIGHT);
}

int position_valid(int x, int y) {
    return(x_valid(x) && y_valid(y));
}GRID_WIDTH
*/

void unit_init(struct unit * unit, int x, int y) {
    unit->texture = NULL;
    unit->w = 0;
    unit->h = 0;
    unit->gem = 0;
    unit->drillpower = 0;
    unit_set_position(unit, x, y);
}

void unit_set_position(struct unit * unit, int x, int y) {
    unit->x = x < 0 ? 0 : x > WINDOW_WIDTH  ? WINDOW_WIDTH  : x;
    unit->y = y < 0 ? 0 : y > WINDOW_HEIGHT ? WINDOW_HEIGHT : y;
}

void unit_move(struct unit * unit, int dx, int dy) {
    int new_x = unit->x + dx;
    int new_y = unit->y + dy;
    if(is_passable(new_x, new_y)) {
        unit_set_position(unit, new_x, new_y);
    }
}

void unit_load_texture(struct unit * unit, const char * filename, SDL_Renderer * renderer) {
    unit->texture = load_texture(renderer, filename, &(unit->w), &(unit->h));
}

void unit_draw(struct unit * unit, SDL_Renderer * renderer) {
    SDL_Rect dst;
    if(unit->texture != NULL) {
        dst.w = unit->w;
        dst.h = unit->h;
        dst.x = unit->x - dst.w/2;
        dst.y = unit->y - dst.h/2;
        SDL_RenderCopy(renderer, unit->texture, NULL, &dst);
    }
    dst.w = dst.h = GEMICON_SIZE;
    for(int k=0; k<unit->gem; k++) {
        dst.x = unit->x - unit->w/2 + (k%5)*GEMICON_SIZE;
        dst.y = unit->y - unit->h/2 + (k/5)*GEMICON_SIZE;
        SDL_RenderCopy(renderer, gemicon, NULL, &dst);
    }
}

void unit_dig(struct unit * unit) {
    if(unit->drillpower > 0) {
        unit->gem += grid_dig(unit->x, unit->y, unit->drillpower);
    }
}
